if [ $# != 2 ]
then
if [ $1 = "h" -o $1 = "H" ]
then
echo "help info"
else
echo "ERROR: Invalid argument amount! Plz input 2 directory names!"
fi
echo "**************************************************************"
echo "* by Richard Zhang, Oct, 2008. *"
echo "* China Contruction Bank, SuZhou Branch *"
echo "* Usage example: 'sh $0
echo "* for help: 'sh $0 h' *"
echo "**************************************************************"
exit 0
fi
没有问题,但是,如果
if [ $# != 2 ]
then
echo "**************************************************************"
echo "* by Richard Zhang, Oct, 2008. *"
echo "* China Contruction Bank, SuZhou Branch *"
echo "* Usage example: 'sh $0
echo "* for help: 'sh $0 h' *"
echo "**************************************************************"
if [ $1 = "h" -o $1 = "H" ]
then
echo "help info"
else
echo "ERROR: Invalid argument amount! Plz input 2 directory names!"
fi
exit 0
fi
则在FreeBSD6.1下运行时,提示“[: =: unexpected operator”
真实奇怪。
if TEST-COMMANDS; then CONSEQUENT-COMMANDS; fi
FILE
参数是 /dev/fd/N
这样的形式,那么就检查文件描述符 “N”。stdin
, stdout
和 stderr
和他们各自的文件描述符也可以用于测试。
Primary | 意义 |
---|---|
[ -a FILE ] |
如果 FILE 存在则为真。 |
[ -b FILE ] |
如果 FILE 存在且是一个块特殊文件则为真。 |
[ -c FILE ] |
如果 FILE 存在且是一个字特殊文件则为真。 |
[ -d FILE ] |
如果 FILE 存在且是一个目录则为真。 |
[ -e FILE ] |
如果 FILE 存在则为真。 |
[ -f FILE ] |
如果 FILE 存在且是一个普通文件则为真。 |
[ -g FILE ] |
如果 FILE 存在且已经设置了SGID则为真。 |
[ -h FILE ] |
如果 FILE 存在且是一个符号连接则为真。 |
[ -k FILE ] |
如果 FILE 存在且已经设置了粘制位则为真。 |
[ -p FILE ] |
如果 FILE 存在且是一个名字管道(F如果O)则为真。 |
[ -r FILE ] |
如果 FILE 存在且是可读的则为真。 |
[ -s FILE ] |
如果 FILE 存在且大小不为0则为真。 |
[ -t FD ] |
如果文件描述符 FD 打开且指向一个终端则为真。 |
[ -u FILE ] |
如果 FILE 存在且设置了SUID (set user ID)则为真。 |
[ -w FILE ] |
如果 FILE 如果 FILE 存在且是可写的则为真。 |
[ -x FILE ] |
如果 FILE 存在且是可执行的则为真。 |
[ -O FILE ] |
如果 FILE 存在且属有效用户ID则为真。 |
[ -G FILE ] |
如果 FILE 存在且属有效用户组则为真。 |
[ -L FILE ] |
如果 FILE 存在且是一个符号连接则为真。 |
[ -N FILE ] |
如果 FILE 存在 and has been mod如果ied since it was last read则为真。 |
[ -S FILE ] |
如果 FILE 存在且是一个套接字则为真。 |
[ FILE1 -nt FILE2 ] |
如果 FILE1 has been changed more recently than FILE2 , or 如果 FILE1 FILE2 does not则为真。 exists and |
[ FILE1 -ot FILE2 ] |
如果 FILE1 比 FILE2 要老, 或者 FILE2 存在且 FILE1 不存在则为真。 |
[ FILE1 -ef FILE2 ] |
如果 FILE1 和 FILE2 指向相同的设备和节点号则为真。 |
[ -o OPTIONNAME ] |
如果 shell选项 “OPTIONNAME” 开启则为真。 |
[ -z STRING ] |
“STRING” 的长度为零则为真。 |
[ -n STRING ] or [ STRING ] |
“STRING” 的长度为非零 non-zero则为真。 |
[ STRING1 == STRING2 ] | 如果2个字符串相同。 “=” may be used instead of “==” for strict POSIX compliance则为真。 |
[ STRING1 != STRING2 ] | 如果字符串不相等则为真。 |
[ STRING1 < STRING2 ] | 如果 “STRING1” sorts before “STRING2” lexicographically in the current locale则为真。 |
[ STRING1 > STRING2 ] | 如果 “STRING1” sorts after “STRING2” lexicographically in the current locale则为真。 |
[ ARG1 OP ARG2 ] | “OP” is one of -eq , -ne , -lt , -le , -gt or -ge . These arithmetic binary operators return true if “ARG1” is equal to, not equal to, less than, less than or equal to, greater than, or greater than or equal to “ARG2”, respectively. “ARG1” and “ARG2” are integers. |
操作 | 效果 |
---|---|
[ ! EXPR ] | 如果 EXPR 是false则为真。 |
[ ( EXPR ) ] | 返回 EXPR 的 值。这样可以用来忽略正常的操作符优先级。 |
[ EXPR1 -a EXPR2 ] | 如果 EXPR1 and EXPR2 全真则为真。 |
[ EXPR1 -o EXPR2 ] | 如果 EXPR1 或者 EXPR2 为真则为真。 |
anny ~>
cat msgcheck.sh
#!/bin/bash
echo "This scripts checks the existence of the messages file."
echo "Checking..."
if [ -f /var/log/messages ]
then
echo "/var/log/messages exists."
fi
echo
echo "...done."
anny ~>
./msgcheck.sh
This scripts checks the existence of the messages file.
Checking...
/var/log/messages exists.
...done.
# These lines will print a message if the noclobber option is set:
if [ -o noclobber ]
then
echo "Your files are protected against accidental overwriting using redirection."
fi
环境 | |
---|---|
以上的例子将在命令行输入后开始工作:
然而,如果你使用依赖环境的测试,当你在脚本中输入 相同的命令你可能得到不用的结果,因为脚本会打开一个新的,没有设置预期的变量和选项的shell。
|
?
变量包含了之前执行命令的退出状态(最近完成的前台进程)。
anny ~>
if [ $? -eq 0 ]
More input>
then echo 'That was a good job!'
More input>
fi
That was a good job!
anny ~>
anny ~>
if ! grep $USER
/etc/passwd
More input>
then echo "your user account is not managed locally"
; fi
your user account is not managed locally
anny >
echo $?
0
anny >
anny >
grep $USER
/etc/passwd
anny >
if [ $? -ne 0 ]
; then echo "not a local account"
; fi
not a local account
anny >
anny >
num
=`wc -l work.txt`
anny >
echo $num
201
anny >
if [ "$num" -gt "150" ]
More input>
then echo ; echo "you've worked hard enough for today."
More input>
echo ; fi
you've worked hard enough for today.
anny >
#!/bin/bash
# Calculate the week number using the date command:
WEEKOFFSET=$[ $(date +"%V") % 2 ]
# Test if we have a remainder. If not, this is an even week so send a message.
# Else, do nothing.
if [ $WEEKOFFSET -eq "0" ]; then
echo "Sunday evening, put out the garbage cans." | mail -s "Garbage cans out" your@your_domain.org
if [ "$(whoami)" != 'root' ]; then
echo "You have no permission to run $0 as non-root user."
exit 1;
fi
[ "$(whoami)" != 'root' ] && ( echo you are using a non-privileged account; exit 1 )
anny >
gender
="female"
anny >
if [[ "$gender" == f* ]]
More input>
then echo "Pleasure to meet you, Madame."
; fi
Pleasure to meet you, Madame.
anny >
-b 当file存在并且是块文件时返回真
-c 当file存在并且是字符文件时返回真
-d 当pathname存在并且是一个目录时返回真
-e 当pathname指定的文件或目录存在时返回真
-f 当file存在并且是正规文件时返回真
-g 当由pathname指定的文件或目录存在并且设置了SGID位时返回为真
-h 当file存在并且是符号链接文件时返回真,该选项在一些老系统上无效
-k 当由pathname指定的文件或目录存在并且设置了“粘滞”位时返回真
-p 当file存在并且是命令管道时返回为真
-r 当由pathname指定的文件或目录存在并且可读时返回为真
-s 当file存在文件大小大于0时返回真
-u 当由pathname指定的文件或目录存在并且设置了SUID位时返回真
-w 当由pathname指定的文件或目录存在并且可执行时返回真。一个目录为了它的内容被访问必然是可执行的。
-o 当由pathname指定的文件或目录存在并且被子当前进程的有效用户ID所指定的用户拥有时返回真。
比较字符写法:
-eq 等于
-ne 不等于
-gt 大于
-lt 小于
-le 小于等于
-ge 大于等于
-z 空串
* = 两个字符相等
* != 两个字符不等
* -n 非空串